Graphics3D 1024,768,32,2
SetBuffer BackBuffer ()
AntiAlias 1
WBuffer 1
HWMultiTex 1

cam=CreateCamera()
PositionEntity cam,0,10,-15


lit=CreateLight()

zombie=LoadAnimMesh ("zombie.b3d")

;/Frames Zombie
ExtractAnimSeq (zombie,2,20); 1  (1)
ExtractAnimSeq (zombie,22,36); 2  (2)
ExtractAnimSeq (zombie,38,47);  1 (3)
ExtractAnimSeq (zombie,48,57);  2  (4)
ExtractAnimSeq (zombie,59,75);     (5)
ExtractAnimSeq (zombie,78,88);    ( ,   ) (6)
ExtractAnimSeq (zombie,91,103);    (7)
ExtractAnimSeq (zombie,106,115);, (8)
ExtractAnimSeq (zombie,117,128); / (9)
ExtractAnimSeq (zombie,129,136);  :-)(10)
ExtractAnimSeq (zombie,137,169);Idle 1(11)
ExtractAnimSeq (zombie,170,200);Idle 2)(12)
;\Frames Zombie

EntityPickMode zombie,2

UpdateNormals zombie
Animate zombie,1,0.5,anim,12

Repeat
anim=11

If KeyDown(200)  
anim=1
MoveEntity zombie,0,0,-0.1
End If

If KeyDown(208)  
anim=1
MoveEntity zombie,0,0,0.1
End If

If KeyDown(203)
TurnEntity zombie,0,-0.5,0
anim=2
End If

If KeyDown(205)
TurnEntity zombie,0,0.5,0
anim=2
End If

If AnimSeq(zombie)<>anim  Animate zombie,1,0.3,anim,12

UpdateWorld()
RenderWorld()
	If FPSTimer>MilliSecs() Then
	fpsc=fpsc+1
	Else
	FPS=fpsc*2
	fpsc=0
	FPSTimer=MilliSecs()+500
	EndIf
	
	x=MouseX()
	y=MouseY()
	
	e=CameraPick( cam,x,y )
	If e<>entity
		If entity Then Draw_Wire_2D(entity,cam,250,250,250)
		entity=e
	EndIf
	
	If entity
		Draw_Wire_2D(entity,cam,250,50,50)
	EndIf
	
	
	Rect x,y-3,1,7	
	Rect x-3,y,7,1

	
Text 100,85,"FPS: "+FPS+". Tris rendered:"+TrisRendered()
Text 100,20,"animseq:"+anim

Flip 
Until KeyHit (1)
End


Function Draw_Wire_2D(mesh,cam,red=0,grn=0,blu=0)
	Color red,grn,blu
	If EntityInView(mesh,cam)=False Then Return
	cnt=CountSurfaces(mesh)
	For a=1 To cnt
		surf=GetSurface(mesh,a)
		For tri=0 To CountTriangles(surf)-1
			TFormPoint VertexX(surf,TriangleVertex(surf,tri,0)),VertexY(surf,TriangleVertex(surf,tri,0)),VertexZ(surf,TriangleVertex(surf,tri,0)),mesh,0
			CameraProject(cam,TFormedX(),TFormedY(),TFormedZ())
			sx1=ProjectedX()
			sy1=ProjectedY()
			TFormPoint VertexX(surf,TriangleVertex(surf,tri,1)),VertexY(surf,TriangleVertex(surf,tri,1)),VertexZ(surf,TriangleVertex(surf,tri,1)),mesh,0
			CameraProject(cam,TFormedX(),TFormedY(),TFormedZ())
			sx2=ProjectedX()
			sy2=ProjectedY()
			TFormPoint VertexX(surf,TriangleVertex(surf,tri,2)),VertexY(surf,TriangleVertex(surf,tri,2)),VertexZ(surf,TriangleVertex(surf,tri,2)),mesh,0
			CameraProject(cam,TFormedX(),TFormedY(),TFormedZ())
			sx3=ProjectedX()
			sy3=ProjectedY()
			If Check_Cull_2D(sx1,sy1,sx2,sy2,sx3,sy3)<0
				Line sx1,sy1,sx2,sy2
				Line sx2,sy2,sx3,sy3
				Line sx3,sy3,sx1,sy1	
			End If
		Next			
	Next
End Function

Function Check_Cull_2D(x1,y1,x2,y2,x3,y3)
	 Return (x1-x2)*(y3-y2)-(y1-y2)*(x3-x2)
End Function
